local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local spec
local _
local sct

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.TimeToDie = s.TimeToDie("target") or 15
	_, x.GCD = s.GlobalCooldown()
	x.Focus = s.Power("player", SPELL_POWER_FOCUS)
	x.FocusPerSecond = a.focusRegeneration()
	spec = s.Spec()
	a.Flash("Aspect of the Hawk", "Aspect of the Cheetah while moving")
	a.Flash("hunters_mark")
	a.Flash("Call Pet")
	a.Flash("Mend Pet")
	a.Flash("Pet Attack")
	a.Flash("Pet Assist")
	a.Flash("Concussive Shot")
	a.Flash("Disengage")
	a.Flash("Feign Death")
	a.Flash("Master's Call")
	a.Flash("Widow Venom")
	a.Flash("Exhilaration")
	_, x.lowDmg, x.hiDmg = UnitRangedDamage("player")
	x.avgDmg = (x.lowDmg + x.hiDmg) / 2
	x.RAP = UnitRangedAttackPower("player")
	x.InCombat = s.InCombat()
	x.Stop = false
	x.Boss = s.Boss("target")
	x.ActiveEnemies = a.ActiveEnemies()
	if spec == 1 then
		-- BM
		sct = s.Casting(77767--[[Cobra Shot]], "player")
		if sct then
			x.Focus = x.Focus + sct * x.FocusPerSecond + 14
		elseif x.GCD > 0 then
			x.Focus = x.Focus + x.GCD * x.FocusPerSecond
		end
		a.Flash("Counter Shot")
		a.Flash("virmens_bite_potion,if=buff.bloodlust.react|target.time_to_die<=60",
				"auto_shot",
				"explosive_trap,if=active_enemies>1",
				"focus_fire,five_stacks=1",
				"serpent_sting,if=!ticking",
				"blood_fury",
				"berserking",
				"fervor,if=enabled&!ticking&focus<=65",
				"bestial_wrath,if=focus>60&!buff.beast_within.up",
				"multi_shot,if=active_enemies>5|(active_enemies>2&buff.beast_cleave.down)",
				"cobra_shot,if=active_enemies>5",
				"rapid_fire,if=!buff.rapid_fire.up",
				"stampede,if=buff.rapid_fire.up|buff.bloodlust.react|target.time_to_die<=25",
				"kill_shot",
				"kill_command",
				"a_murder_of_crows,if=enabled&!ticking",
				"glaive_toss,if=enabled",
				"lynx_rush,if=enabled&!dot.lynx_rush.ticking",
				"dire_beast,if=enabled&focus<=90",
				"barrage,if=enabled",
				"powershot,if=enabled",
				"arcane_shot,if=buff.thrill_of_the_hunt.react",
				"focus_fire,five_stacks=1,if=!ticking&!buff.beast_within.up",
				"cobra_shot,if=dot.serpent_sting.remains<6",
				"arcane_shot,if=focus>=61|buff.beast_within.up",
				"cobra_shot")
	elseif spec == 2 then
		-- MM
		sct = s.Casting(56641--[[Steady Shot]], "player")
		if sct then
			x.Focus = x.Focus + sct * x.FocusPerSecond + 14
		elseif x.GCD > 0 then
			x.Focus = x.Focus + x.GCD * x.FocusPerSecond
		end
		a.Flash("Silencing Shot")
		if s.HealthPercent("target") <= 80 or s.Dummy("target") then
			a.Flash("virmens_bite_potion,if=buff.bloodlust.react|target.time_to_die<=60",
					"auto_shot",
					"explosive_trap,if=active_enemies>1",
					"blood_fury",
					"berserking",
					"powershot,if=enabled",
					"lynx_rush,if=enabled&!dot.lynx_rush.ticking",
					"multi_shot,if=active_enemies>5",
					"steady_shot,if=active_enemies>5",
					"fervor,if=enabled&focus<=50",
					"rapid_fire,if=!buff.rapid_fire.up",
					"stampede,if=buff.rapid_fire.up|buff.bloodlust.react|target.time_to_die<=25",
					"a_murder_of_crows,if=enabled&!ticking",
					"dire_beast,if=enabled",
					"glaive_toss,if=enabled",
					"barrage,if=enabled",
					"steady_shot,if=buff.pre_steady_focus.up&buff.steady_focus.remains<=5",
					"serpent_sting,if=!ticking",
					"chimera_shot",
					"steady_shot,if=buff.steady_focus.remains<(action.steady_shot.cast_time+1)&!in_flight",
					"kill_shot",
					"aimed_shot,if=buff.master_marksman_fire.react",
					"arcane_shot,if=buff.thrill_of_the_hunt.react",
					"aimed_shot,if=cast_time<1.7",
					"arcane_shot,if=focus>=60|(focus>=43&(cooldown.chimera_shot.remains>=action.steady_shot.cast_time))&(!buff.rapid_fire.up&!buff.bloodlust.react)",
					"steady_shot")
		else
			a.Flash("virmens_bite_potion,if=buff.bloodlust.react|target.time_to_die<=60",
					"auto_shot",
					"explosive_trap,if=active_enemies>1",
					"blood_fury",
					"berserking",
					"powershot,if=enabled",
					"lynx_rush,if=enabled&!dot.lynx_rush.ticking",
					"multi_shot,if=active_enemies>5",
					"steady_shot,if=active_enemies>5",
					"fervor,if=enabled&focus<=50",
					"rapid_fire,if=!buff.rapid_fire.up",
					"stampede,if=buff.rapid_fire.up|buff.bloodlust.react|target.time_to_die<=25",
					"a_murder_of_crows,if=enabled&!ticking",
					"dire_beast,if=enabled",
					"serpent_sting,if=!ticking",
					"chimera_shot",
					"steady_shot,if=buff.pre_steady_focus.up&buff.steady_focus.remains<6",
					"aimed_shot",
					"steady_shot")
		end
	elseif spec == 3 then
		-- SV
		sct = s.Casting(77767--[[Cobra Shot]], "player")
		if sct then
			x.Focus = x.Focus + sct * x.FocusPerSecond + 14
		elseif x.GCD > 0 then
			x.Focus = x.Focus + x.GCD * x.FocusPerSecond
		end
		a.Flash("Counter Shot")
		a.Flash("virmens_bite_potion,if=buff.bloodlust.react|target.time_to_die<=60",
				"blood_fury",
				"berserking",
				"auto_shot",
				"explosive_trap,if=active_enemies>1",
				"fervor,if=enabled&focus<=50",
				"a_murder_of_crows,if=enabled&!ticking",
				"lynx_rush,if=enabled&!dot.lynx_rush.ticking",
				"explosive_shot,if=buff.lock_and_load.react",
				"glaive_toss,if=enabled",
				"powershot,if=enabled",
				"barrage,if=enabled",
				"multi_shot,if=active_enemies>3",
				"cobra_shot,if=active_enemies>3",
				"serpent_sting,if=!ticking&target.time_to_die>=10",
				"explosive_shot,if=cooldown_react",
				"kill_shot",
				"black_arrow,if=!ticking&target.time_to_die>=8",
				"multi_shot,if=buff.thrill_of_the_hunt.react&dot.serpent_sting.remains<2",
				"arcane_shot,if=buff.thrill_of_the_hunt.react",
				"rapid_fire,if=!buff.rapid_fire.up",
				"dire_beast,if=enabled",
				"stampede,if=buff.rapid_fire.up|buff.bloodlust.react|target.time_to_die<=25",
				"cobra_shot,if=dot.serpent_sting.remains<6",
				"arcane_shot,if=focus>=67",
				"cobra_shot")
	end
end)

